Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.novell.nds.dirxml.util
Class DxWire

    java.lang.Object
      com.novell.nds.dirxml.util.DxWire

    public class DxWire

extends Object

Utility class to construct NDAP wire-format buffers for DirXML subverbs.

The construction methods in this class construct the wire format starting with the DirXML subverb number. The part of the NDAP wire format that precedes the verb-specific data is not constructed.

Each DirXML subverb is documented under its manifest constant (e.g., `DSVR_DRIVER_STATE`). Each subverb must be issued as part of a `DSV_SET_REPLICATION_FILTER` request or as part of a `DSV_GET_REPLICATION_FILTER` request. The individual subverb documentation indicates with which verb or verbs the subverb can be used.

When issuing a DirXML subverb a return code of `0` always indicates success.

Nested Class Summary
`static class` | `DxWire.DxWireData` Utility class to aggregate wire-format data.

Field Summary
`static int` | `DSV_GET_REPLICATION_FILTER` eDirectory NCP verb, used with various and sundry subverbs to get DirXML state and to read special DirXML values.
`static int` | `DSV_SET_REPLICATION_FILTER` eDirectory NCP verb, used with various and sundry subverbs to control DirXML, and to set special DirXML values.
`static int` | `DSVR_ABORT_JOB` Subverb used to abort a DirXML job if the job is running.
`static int` | `DSVR_CACHE_UTIL` Subverb used to view the contents of a stopped driver's cache, and to remove transaction records from the stopped driver's cache.
`static int` | `DSVR_CHECK_JOB_CONFIG` Subverb used to check a DirXML-Job object's configuration.
`static int` | `DSVR_CHECK_OBJECT_PASSWORD` Subverb used to perform a check password synchronization request on a specified object and driver.
`static int` | `DSVR_CLOSE_CHUNKED_RESULT` Subverb used to release all resources associated with a "chunked" result.
`static int` | `DSVR_DISCOVER_JOBS` Subverb used to get the available job definitions on the server.
`static int` | `DSVR_DRIVER_CACHE_LIMIT` Deprecated.
`static int` | `DSVR_DRIVER_SET` Subverb used to set and get the active driver set for an eDirectory server.
`static int` | `DSVR_DRIVER_START_OPTION` Subverb used to set and get a driver's startup option.
`static int` | `DSVR_DRIVER_STATE` Subverb used to set and get a driver's running state.
`static int` | `DSVR_GET_CHUNKED_RESULT` Subverb used to retrieve a result that may be very large.
`static int` | `DSVR_GET_DIRXML_VERSION` Subverb used to retrieve the DirXML Engine version number.
`static int` | `DSVR_GET_JOB_STATE` Subverb used to get the current running state and next run time of a DirXML job.
`static int` | `DSVR_GET_PASSWORDS_STATE` Subverb used to determine if the following passwords are set for a driver.
`static int` | `DSVR_GET_SERVER_CERT` Subverb used to get the RSA Public Key certificate for the DirXML server.
`static int` | `DSVR_INIT_DRIVER_OBJECT` Subverb used to initialize any DirXML Engine-created values on a driver object.
`static int` | `DSVR_LOG_EVENTS` Subverb used to set a list of IDs of events to be logged.
`static int` | `DSVR_MIGRATE_APP` Subverb used to queue a query to the application on the driver's Subscriber channel.
`static int` | `DSVR_NAMED_PASSWORD` Subverb used to set and clear named passwords for an object.
`static int` | `DSVR_NOTIFY_JOB_UPDATE` Notify the DirXML Engine that the data associated with a DirXML-Job object has changed.
`static int` | `DSVR_OPEN_DRIVER_ACTION` Subverb used to send an XDS command or event document to a driver.
`static int` | `DSVR_QUEUE_EVENT` Subverb used to cache an arbitrary event document for the driver.
`static int` | `DSVR_REGENERATE_KEY` Subverb used to cause a new public/private key pair to be generated for the DirXML server.
`static int` | `DSVR_REMOTE_LOADER_PASSWORD` Subverb used to set and clear the remote loader password for a driver.
`static int` | `DSVR_RESYNC_DRIVER` Subverb used to cause a driver resync.
`static int` | `DSVR_SHIM_PASSWORD` Subverb used to set and clear the application password for a driver.
`static int` | `DSVR_START_JOB` Subverb used to manually start a DirXML job if the job is enabled and not already running.

Constructor Summary
`DxWire()` Construct an instance of DxWire that can be used to construct wire-format buffers.
`DxWire(int dnFormatFlags)` Construct an instance of DxWire that can be used to construct wire-format buffers.

Method Summary
`DxWire.DxWireData` | `constructAbortJob(String jobObjectDN)` Construct a wire-format buffer to send a DSVR_ABORT_JOB version 0 request to a DirXML server.
`DxWire.DxWireData` | `constructCheckJobConfig(String jobObjectDN, String language, String country, int timeoutPeriod)` Construct a wire-format buffer to send a DSVR_CHECK_JOB_CONFIG version 0 request to a DirXML server.
`DxWire.DxWireData` | `constructCheckObjectPassword(String objectDN, String driverDN)` Construct a wire-format buffer to perform a check object password command for a specific user and DirXML driver.
`DxWire.DxWireData` | `constructCloseChunkedResult(int handle)` Construct a wire-format buffer to retrieve data available using the `DSVR_CLOSE_CHUNKED_RESULT` subverb.
`DxWire.DxWireData` | `constructDeleteDriverCache(String driverDN, int positionToken, int transactionCount, String eventID)` Construct a wire-format buffer to send a DSVR_CACHE_UTIL version 1 request to a DirXML driver.
`DxWire.DxWireData` | `constructDiscoverAllJobs(String dn, int timeoutPeriod)` Construct a wire-format buffer to send a DSVR_DISCOVER_JOBS version 1 request to a DirXML server.
`DxWire.DxWireData` | `constructDiscoverJobs(String dn, int timeoutPeriod)` Construct a wire-format buffer to send a DSVR_DISCOVER_JOBS version 0 request to a DirXML server.
`DxWire.DxWireData` | `constructGetChunkedResult(int handle, int additionalTimeout, int maxResponseSize)` Construct a wire-format buffer to retrieve data available using the `DSVR_GET_CHUNKED_RESULT` subverb.
`DxWire.DxWireData` | `constructGetDirXMLVersion()` Construct a wire-format buffer to get the DirXML version on a server.
`DxWire.DxWireData` | `constructGetDriverCacheLimit(String driverDN)` Deprecated.
`DxWire.DxWireData` | `constructGetDriverSet()` Construct a wire-format buffer to get the DN of the DirXML-DriverSet object associated with a server.
`DxWire.DxWireData` | `constructGetDriverStartOption(String driverDN)` Construct a wire-format buffer to get a DirXML driver's start up option.
`DxWire.DxWireData` | `constructGetDriverState(String driverDN)` Construct a wire-format buffer to get a DirXML driver's state.
`DxWire.DxWireData` | `constructGetJobState(String jobObjectDN)` Construct a wire-format buffer to send a DSVR_GET_JOB_STATE version 0 request to a DirXML server.
`DxWire.DxWireData` | `constructGetPasswordsState(String driverDN)` Construct a wire-format buffer to send a DSVR_GET_PASSWORDS_STATE version 0 request to a DirXML driver.
`DxWire.DxWireData` | `constructGetServerCert(int returnFormat)` Construct a wire-format buffer to send a DSVR_GET_SERVER_CERT version 0 request to a DirXML server.
`DxWire.DxWireData` | `constructInitDriverObject(String driverDN)` Construct a wire-format buffer to perform a driver object init on a new driver object.
`DxWire.DxWireData` | `constructListNamedPasswords_v5(String driverDN, int maxResponseSize)` Construct a wire-format buffer to return a list of named passwords and their description strings for a DirXML driver.
`DxWire.DxWireData` | `constructListNamedPasswords(String driverDN, int maxResponseSize)` Deprecated.
`DxWire.DxWireData` | `constructMigrateApp(String driverDN, byte[] xdsDocumentBytes)` Construct a wire-format buffer to send an query document to a DirXML driver to cause the engine to migrate all objects returned as the result of the query into DirXML.
`DxWire.DxWireData` | `constructNotifyJobUpdate(String jobObjectDN)` Construct a wire-format buffer to send a DSVR_NOTIFY_JOB_UPDATE version 0 request to a DirXML server.
`DxWire.DxWireData` | `constructOpenDriverAction(String driverDN, int timeoutPeriod, byte[] xdsDocumentBytes)` Construct a wire-format buffer to send an XDS command document to a DirXML driver.
`DxWire.DxWireData` | `constructOpenDriverAction(String driverDN, int timeoutPeriod, byte[] xdsDocumentBytes, int version)` Construct a wire-format buffer to send an XDS command document to a DirXML driver.
`DxWire.DxWireData` | `constructQueueEvent(String driverDN, byte[] xdsDocumentBytes)` Construct a wire-format buffer to send an query document to a DirXML driver to cause the engine to migrate all objects returned as the result of the query into DirXML.
`DxWire.DxWireData` | `constructReadDriverCache(String driverDN, int timeoutPeriod, int positionToken, int maxTransactions)` Construct a wire-format buffer to send a DSVR_CACHE_UTIL version 0 request to a DirXML driver.
`DxWire.DxWireData` | `constructRegenerateKey(int type)` Construct a wire-format buffer to send a DSVR_REGENERATE_KEY version 0 request to a DirXML driver.
`DxWire.DxWireData` | `constructResetAllNamedPasswords(String driverDN)` Construct a wire-format buffer to clear all named passwords for a DirXML driver.
`DxWire.DxWireData` | `constructResetAppPassword(String driverDN)` Construct a wire-format buffer to clear the shim password for a DirXML driver.
`DxWire.DxWireData` | `constructResetDriverSet()` Construct a wire-format buffer to associate from a server the currently associated DirXML-DriverSet object.
`DxWire.DxWireData` | `constructResetLogEvents(String objectDN)` Construct a wire-format buffer to clear the list of event IDs to be logged on a DirXML-DriverSet or DirXML-Driver object.
`DxWire.DxWireData` | `constructResetNamedPassword(String driverDN, String key)` Construct a wire-format buffer to clear a named password for a DirXML driver.
`DxWire.DxWireData` | `constructResetRemoteLoaderPassword(String driverDN)` Construct a wire-format buffer to clear the Remote Loader password for a DirXML driver.
`DxWire.DxWireData` | `constructResetShimPassword(String driverDN)` Deprecated.
`DxWire.DxWireData` | `constructResyncDriver(String driverDN)` Construct a wire-format buffer to cause a manual resync of a DirXML driver's state.
`DxWire.DxWireData` | `constructResyncDriver(String driverDN, int seconds)` Construct a wire-format buffer to cause a manual resync of a DirXML driver's state.
`DxWire.DxWireData` | `constructSetAppPassword(String driverDN, byte[] encryptedPassword, byte[] certHash)` Construct a wire-format buffer to set the shim password for a DirXML driver using the "send-encrypted" form.
`DxWire.DxWireData` | `constructSetAppPassword(String driverDN, String password)` Deprecated.
`DxWire.DxWireData` | `constructSetDriverCacheLimit(String driverDN, int newLimit)` Deprecated.
`DxWire.DxWireData` | `constructSetDriverSet(String driverSetDN)` Construct a wire-format buffer to associate a DirXML-DriverSet object with a server.
`DxWire.DxWireData` | `constructSetDriverStartOption(String driverDN, int newStartOption, boolean noResync)` Construct a wire-format buffer to set a DirXML driver's start option.
`DxWire.DxWireData` | `constructSetDriverState(String driverDN, int newState)` Construct a wire-format buffer to set a DirXML driver's state.
`DxWire.DxWireData` | `constructSetLogEvents(String objectDN, int[] eventIDs)` Construct a wire-format buffer to set the list of event IDs to be logged on a DirXML-DriverSet or DirXML-Driver object.
`DxWire.DxWireData` | `constructSetNamedPassword(String driverDN, String key, byte[] encryptedPassword, byte[] certHash, String description)` Construct a wire-format buffer to set a named password for a DirXML driver, with encrypted password bytes.
`DxWire.DxWireData` | `constructSetNamedPassword(String driverDN, String key, String password)` Deprecated.
`DxWire.DxWireData` | `constructSetNamedPassword(String driverDN, String key, String password, String description)` Deprecated.
`DxWire.DxWireData` | `constructSetRemoteLoaderPassword(String driverDN, byte[] encryptedPassword, byte[] certHash)` Construct a wire-format buffer to set the Remote Loader password for a DirXML driver.
`DxWire.DxWireData` | `constructSetRemoteLoaderPassword(String driverDN, String password)` Deprecated.
`DxWire.DxWireData` | `constructSetShimPassword(String driverDN, String password, boolean dirXML_1x)` Deprecated.
`DxWire.DxWireData` | `constructStartJob(String jobObjectDN)` Construct a wire-format buffer to send a DSVR_START_JOB version 0 request to a DirXML server.
`int` | `extractCheckObjectPasswordResult(byte[] verbResponseData, int responseSize)` Extract the result data from the wire data returned as a result of `DSV_SET_REPLICATION_FILTER` with `DSVR_CHECK_OBJECT_PASSWORD`.
`byte[]` | `extractChunkedResultBytes(byte[] verbResponseData, int responseSize)` Extract the result data from the wire data returned as a result of `DSV_GET_REPLICATION_FILTER` with `DSVR_GET_RESULT_CHUNK`.
`int` | `extractDirXMLVersion(byte[] verbResponseData, int responseSize)` Extract the version value returned as a result of `DSV_GET_REPLICATION_FILTER` with `DSVR_GET_DIRXML_VERSION`.
`int` | `extractDriverActionResultHandle(byte[] verbResponseData, int responseSize)` Extract the result data handle from the wire data returned as a result of `DSV_SET_REPLICATION_FILTER` with `DSVR_OPEN_DRIVER_ACTION`.
`int` | `extractDriverActionResultSize(byte[] verbResponseData, int responseSize)` Extract the result data size from the wire data returned as a result of `DSV_SET_REPLICATION_FILTER` with `DSVR_OPEN_DRIVER_ACTION`.
`int` | `extractDriverCacheLimit(byte[] verbResponseData, int responseSize)` Deprecated.
`String` | `extractDriverSetDN(byte[] verbResponseData, int responseSize)` Extract the DN from the wire data returned as a result of `DSV_GET_REPLICATION_FILTER` with `DSVR_DRIVER_SET`.
`int` | `extractDriverStartOption(byte[] verbResponseData, int responseSize)` Extract the sdriver start up option value returned as a result of `DSV_GET_REPLICATION_FILTER` with `DSVR_DRIVER_START_OPTION`.
`int` | `extractDriverState(byte[] verbResponseData, int responseSize)` Extract the state value returned as a result of `DSV_GET_REPLICATION_FILTER` with `DSVR_DRIVER_STATE`.
`boolean[]` | `extractGetPasswordsState(byte[] verbResponseData, int responseSize)` Extract information on the passwords state returned from a DSVR_GET_PASSWORDS_STATE verb, version 0.
`int` | `extractJobConfigState(byte[] verbResponseData, int responseSize)` Extract the 32-bit value from the results of a DSVR_GET_JOB_STATE request that contains the job's configuration state.
`long` | `extractJobNextTime(byte[] verbResponseData, int responseSize)` Extract the 32-bit value from the results of a DSVR_GET_JOB_STATE request that contains the job's next run time and return it as a `long` that can be used with `java.util.Date`.
`int` | `extractJobRunningState(byte[] verbResponseData, int responseSize)` Extract the 32-bit value from the results of a DSVR_GET_JOB_STATE request that contains the job's running state.
`int` | `extractNamedPasswordsCount(byte[] verbResponseData, int responseSize)` Extract the count of password keys (version 3) or password key/description pairs (version 5) from the return data from `DSV_SET_REPLICATION_FILTER` with `DSVR_NAMED_PASSWORD`, version 3 or 5.
`int` | `extractNamedPasswordsSize(byte[] verbResponseData, int responseSize)` Extract the total size required for the return data from `DSV_SET_REPLICATION_FILTER` with `DSVR_NAMED_PASSWORD`, version 3.
`String` | `extractPasswordName(byte[] verbResponseData, int responseSize, int keyIndex)` Deprecated.
`String[]` | `extractPasswordNameAndDesc(byte[] verbResponseData, int responseSize, int keyIndex)` Extract a password key (name) and description from the return data from `DSV_SET_REPLICATION_FILTER` with `DSVR_NAMED_PASSWORD`, version 5.
`int` | `extractReadDriverCachePositionToken(byte[] verbResponseData, int responseSize)` Extract the offset token from the wire data returned as a result of `DSV_SET_REPLICATION_FILTER` with `DSVR_CACHE_UTIL`, version 0.
`int` | `extractReadDriverCacheResultHandle(byte[] verbResponseData, int responseSize)` Extract the result data handle from the wire data returned as a result of `DSV_SET_REPLICATION_FILTER` with `DSVR_CACHE_UTIL`, version 0.
`int` | `extractReadDriverCacheResultSize(byte[] verbResponseData, int responseSize)` Extract the result data size from the wire data returned as a result of `DSV_SET_REPLICATION_FILTER` with `DSVR_CACHE_UTIL`, version 0.
`byte[]` | `extractServerCert(byte[] verbResponseData, int responseSize)` Extract the X.509 certificate data returned in response to a DSVR_GET_SERVER_CERT request.
`int` | `getDnFormatFlags()` Return the DN format flags used with this instance.
`void` | `setDnFormat(int dnFormat)` Set the DN format based on an XdsDN format number.
`void` | `setDnFormatFlags(int dnFormatFlags)` Set the DN format flags used with this instance.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### DSV_SET_REPLICATION_FILTER

    public static final int DSV_SET_REPLICATION_FILTER

  eDirectory NCP verb, used with various and sundry subverbs to control DirXML, and to set special DirXML values.

  See Also:
    Constant Field Values

### DSV_GET_REPLICATION_FILTER

    public static final int DSV_GET_REPLICATION_FILTER

  eDirectory NCP verb, used with various and sundry subverbs to get DirXML state and to read special DirXML values.

  See Also:
    Constant Field Values

### DSVR_DRIVER_STATE

    public static final int DSVR_DRIVER_STATE

  Subverb used to set and get a driver's running state.

  Set a Driver's State

    The "set" variant is used to start and stop drivers, and to cause a driver to retrieve the associated application's schema. To start a stopped driver, set the state to `DxConst.VR_DRIVER_STARTING`. To stop a running driver, set the state to `DxConst.VR_DRIVER_SHUTDOWN_PENDING`.

    Verb:
      `DSV_SET_REPLICATION_FILTER`

    Rights needed:
      Write access to the DirXML-AccessRun attribute on the target DirXML-Driver object.

    Wire format:

           uint32     DSVR_DRIVER_STATE (1)
           uint32     version (0)
           uint32     DN format flags
           uint32     state value (DxConst.VR_DRIVER_STARTING,
                                   DxConst.VR_DRIVER_SHUTDOWN_PENDING,
                                   DxConst.VR_DRIVER_GET_SCHEMA)
           uint32     length of driver DN in bytes
           uint16+    driver DN

    Wire format of returned data:
      There is no data returned.

  Get a Driver's State

    The "get" variant is used to retrieve the current running state of a driver.

    Verb:
      `DSV_GET_REPLICATION_FILTER`

    Rights needed:
      Read access to the DirXML-AccessRun attribute on the target DirXML-Driver object.

    Wire format:

           uint32     DSVR_DRIVER_STATE (1)
           uint32     version (0)
           uint32     DN format flags
           uint32     length of driver DN in bytes
           uint16+    driver DN

    Wire format of returned data:

           uint32     current state value

  Availability:
    DirXML 1.0 onward

  See Also:
    `constructSetDriverState(java.lang.String,int)`, `constructGetDriverState(java.lang.String)`, `extractDriverState(byte[],int)`, Constant Field Values

### DSVR_DRIVER_SET

    public static final int DSVR_DRIVER_SET

  Subverb used to set and get the active driver set for an eDirectory server.

  Set the Active Driver Set

    Verb:
      `DSV_SET_REPLICATION_FILTER`

    Rights needed:
      Supervisor rights to the NCP-Server object corresponding to the target eDirectory server.

    Wire format:

           uint32     DSVR_DRIVER_SET (2)
           uint32     version (0)
           uint32     DN format flags
           uint32     length of driver set DN in bytes
           uint16+    driver set DN

    Wire format of returned data:
      There is no data returned.

  Clear the Active Driver Set

    Verb:
      `DSV_SET_REPLICATION_FILTER`

    Rights needed:
      Supervisor rights to the NCP-Server object corresponding to the target eDirectory server.

    Wire format:

           uint32     DSVR_DRIVER_SET (2)
           uint32     version (1)
           uint32     DN format flags

    Wire format of returned data:
      There is no data returned.

  Get the Active Driver Set

    Verb:
      `DSV_GET_REPLICATION_FILTER`

    Rights needed:
      None

    Wire format:

           uint32     DSVR_DRIVER_SET (2)
           uint32     version (0)
           uint32     DN format flags

    Wire format of returned data:

           uint32     length of DN in bytes
           uint16+    driver set DN

  Notes:
    This subverb only operates on the reference to the DirXML-DriverSet object that is contained on the pseudo-server. There is also a link to the server on the DirXML-DriverSet object contained in the DirXML-ServerList attribute that must be removed or added, depending on the operation being performed.

    If no driver set is associated with the server a `-602` (`DSErr.ERR_NO_SUCH_VALUE`) error is returned when the "get" variant is issued.

  Availability:
    DirXML 1.0 onward

  See Also:
    `constructSetDriverSet(java.lang.String)`, `constructResetDriverSet()`, `extractDriverSetDN(byte[],int)`, Constant Field Values

### DSVR_RESYNC_DRIVER

    public static final int DSVR_RESYNC_DRIVER

  Subverb used to cause a driver resync.

  Initiate a Manual Resync

    Verb:
      `DSV_GET_REPLICATION_FILTER`

    Rights needed:
      Write access to the DirXML-AccessMigrate attribute on the target DirXML-Driver object.

    Wire format:

           uint32     DSVR_RESYNC_DRIVER (3)
           uint32     version (0)
           uint32     DN format flags
           uint32     length of driver DN in bytes
           uint16+    driver DN

    Wire format of returned data:
      There is no data returned.

  Initiate a Time-Constrained Manual Resync

    Verb:
      `DSV_GET_REPLICATION_FILTER`

    Rights needed:
      Write access to the DirXML-AccessMigrate attribute on the target DirXML-Driver object.

    Wire format:

           uint32     DSVR_RESYNC_DRIVER (3)
           uint32     version (1)
           uint32     DN format flags
           uint32     length of driver DN in bytes
           uint16+    driver DN
           uint8*     0-3 bytes for alignment
           uint32     starting time for resync (seconds in eDirectory TIME syntax)

    Wire format of returned data:
      There is no data returned.

  Notes:
    The "starting time for resync" specifies the earliest creation or modification time that objects may have and still be part of the resync set

  Availability:
    Version 0: DirXML 1.0 onward
    Version 1: Identity Manager 2.0 onward

  See Also:
    `constructResyncDriver(java.lang.String)`, `constructResyncDriver(java.lang.String,int)`, Constant Field Values

### DSVR_DRIVER_START_OPTION

    public static final int DSVR_DRIVER_START_OPTION

  Subverb used to set and get a driver's startup option.

  Set the Driver Start Option

    Verb:
      `DSV_SET_REPLICATION_FILTER`

    Rights needed:
      Write access to the DirXML-AccessConfigure attribute on the target DirXML-Driver object.

    Wire format:

           uint32     DSVR_DRIVER_START_OPTION (5)
           uint32     version (0 or 1)
           uint32     DN format flags
           uint32     startup option (DxConst.VR_DRIVER_DISABLED,
                                      DxConst.VR_DRIVER_MANUAL_START,
                                      DxConst.VR_DRIVER_AUTO_START)
           uint32     length of driver DN in bytes
           uint16+    driver DN

    Wire format of returned data:
      There is no data returned.

    Notes:
      A driver's start option may not be changed while the driver is running.
      Version 1 suppresses the normal automatic resync that occurs when setting a disabled driver to something other than disabled.

  Get the Driver Start Option

    Verb:
      `DSV_GET_REPLICATION_FILTER`

    Rights needed:
      Read access to the DirXML-AccessConfigure attribute on the target DirXML-Driver object.

    Wire format:

           uint32     DSVR_DRIVER_START_OPTION (5)
           uint32     version (0)
           uint32     DN format flags
           uint32     length of driver DN in bytes
           uint16+    driver DN

    Wire format of returned data:

           uint32     startup option value

  Availability:
    Version 0: DirXML 1.0 onward
    Version 1: Identity Manager 2.0 onward

  See Also:
    `constructSetDriverStartOption(java.lang.String,int,boolean)`, `constructGetDriverStartOption(java.lang.String)`, `extractDriverStartOption(byte[],int)`, Constant Field Values

### DSVR_DRIVER_CACHE_LIMIT

    public static final int DSVR_DRIVER_CACHE_LIMIT

  Deprecated.
  Subverb used to set and get a driver's cache size limit. Note that a cache limit value of `0` means unlimited.

  Driver cache limits are not recommended.

  Set a Driver's Cache Limit

    Verb:
      `DSV_SET_REPLICATION_FILTER`

    Rights needed:
      Write access to the DirXML-AccessConfigure attribute on the target DirXML-Driver object.

    Wire format:

           uint32     DSVR_DRIVER_CACHE_LIMIT (6)
           uint32     version (0)
           uint32     DN format flags
           uint32     cache limit value (0 or size in kilobytes)
           uint32     length of driver DN in bytes
           uint16+    driver DN

    Wire format of returned data:
      There is no data returned.

  Get a Driver's Cache Limit

    Verb:
      `DSV_GET_REPLICATION_FILTER`

    Rights needed:
      Read access to the DirXML-AccessConfigure attribute on the target DirXML-Driver object.

    Wire format:

           uint32     DSVR_DRIVER_CACHE_LIMIT (6)
           uint32     version (0)
           uint32     DN format flags
           uint32     length of driver DN in bytes
           uint16+    driver DN

    Wire format of returned data:

           uint32     cache limit value

  Availability:
    DirXML 1.0 onward

  See Also:
    `constructSetDriverCacheLimit(java.lang.String,int)`, `constructGetDriverCacheLimit(java.lang.String)`, `extractDriverCacheLimit(byte[],int)`, Constant Field Values

### DSVR_MIGRATE_APP

    public static final int DSVR_MIGRATE_APP

  Subverb used to queue a query to the application on the driver's Subscriber channel. When the DirXML engine processes the query the engine will migrate into eDirectory all application objects returned as the result of the query.

  Migrate into eDirectory

    Verb:
      `DSV_SET_REPLICATION_FILTER`

    Rights needed:
      Write access to the DirXML-AccessMigrate attribute on the target DirXML-Driver object.

    Wire format:

           uint32     DSVR_MIGRATE_APP (7)
           uint32     version (0)
           uint32     DN format flags
           uint32     length of driver DN in bytes
           uint16+    driver DN
           uint8*     0 to 3 bytes for alignment to 32-bit boundary
           uint32     size of query document data in bytes
           uint8*     query document data

    Wire format of returned data:
      There is no data returned.

    Notes:
      The query document data must be a well-formed, serialized XML document.

  Availability:
    DirXML 1.0 onward

  See Also:
    `constructMigrateApp(java.lang.String,byte[])`, Constant Field Values

### DSVR_SHIM_PASSWORD

    public static final int DSVR_SHIM_PASSWORD

  Subverb used to set and clear the application password for a driver. The application password is used by the application shim to authenticate to the connected application.

  Note that many of the subverb versions are obsolete and deprecated.

  Set the Application Password

    Verb:
      `DSV_SET_REPLICATION_FILTER`

    Rights needed:
      Write access to the DirXML-AccessConfigure attribute on the target DirXML-Driver object.

    Wire format:

           uint32     DSVR_SHIM_PASSWORD (9)
           uint32     version (0, 2, 3, or 5)
           uint32     DN format flags
           uint32     length of driver DN in bytes
           uint16+    driver DN
           uint8*     0 to 3 bytes for alignment to 32-bit boundary
           uint32     size of password data bytes
           uint8*     password data bytes (see version notes and note for encrypted password data format)

    Wire format of returned data:
      There is no data returned.

  Clear the Application Password

    Verb:
      `DSV_SET_REPLICATION_FILTER`

    Rights needed:
      Write access to the DirXML-AccessConfigure attribute on the target DirXML-Driver object.

    Wire format:

           uint32     DSVR_SHIM_PASSWORD (9)
           uint32     version (1 or 4)
           uint32     DN format flags
           uint32     length of driver DN in bytes
           uint16+    driver DN

    Wire format of returned data:
      There is no data returned.

  Notes on versions:
    Deprecated. Version 0:
      Password data bytes are the client's platform encoding of the password characters. Note that when used with DirXML 1.x a terminating null character is required on the password data.
    Deprecated. Version 1:
      Clear the password value.
    Deprecated. Version 2:
      Password data bytes are the UTF-8 encoding of the password characters. No terminating null is required, but is allowed.
    Deprecated. Version 3:
      Set the application password only. If a Remote Loader password is set then the RL password remains at its current value. Password data bytes are the UTF-8 encoding of the password characters. No terminating null character is required, but is allowed.
    Version 4:
      Clear the application password only. If a Remote Loader password is set then the RL password remains at its current value.
    Version 5:
      Set the application password only. The password data bytes are the UTF-8 encoding of the password characters that has been encrypted. If a remote loader password is set then the RL password remains at its current value.
      Encrypted data format
        The password data is encrypted using an RSA public key that is obtained using the `DSVR_GET_SERVER_CERT` subverb. The specific algorithm variant used is RSAES-OAEP with default parameters. In addition to the encrypted password data, the SHA-1 hash of the public key certificate bytes is sent to ensure that corresponding key pairs are used. The format, therefore, of the password data bytes is as follows:

             uint8{20}  20 byte SHA-1 hash of the X.509 public key certificate
                        containing the public key used to encrypt the password data
             uint8*     RSAES-OAEP encrypted password data

  The Remote Loader password.
    The Remote Loader password is embedded in a delimited fashion in the shim password value (for historical reasons). Versions 3, 4, and 5 affect only the application password portion of the shim password. Versions 0, 1, and 2 affect the whole shim password value (i.e., if the client doesn't embed the remote loader password in the application password data then the remote loader password is lost).

  Availability:
    Deprecated. Version 0: DirXML 1.0 onward.
    Deprecated. Version 1: DirXML 1.0 onward.
    Deprecated. Version 2: Identity Manager 2.0 onward.
    Deprecated. Version 3: Identity Manager 3.0 onward.
    Version 4: Identity Manager 3.0 onward.
    Version 5: Identity Manager 3.0.1 onward.

  See Also:
    `constructSetShimPassword(java.lang.String,java.lang.String,boolean)`, `constructSetAppPassword(java.lang.String,java.lang.String)`, `constructSetAppPassword(java.lang.String,byte[],byte[])`, `constructResetShimPassword(java.lang.String)`, `constructResetAppPassword(java.lang.String)`, `DSVR_REMOTE_LOADER_PASSWORD`, Constant Field Values

### DSVR_LOG_EVENTS

    public static final int DSVR_LOG_EVENTS

  Subverb used to set a list of IDs of events to be logged. This causes an event ID list on the target DirXML-DriverSet or DirXML-Driver objects to be updated.

  Set Event ID List

    Verb:
      `DSV_SET_REPLICATION_FILTER`

    Rights needed:
      Write access to the DirXML-AccessConfigure attribute on the target DirXML-Driver object.

    Wire format:

           uint32     DSVR_LOG_EVENTS (10)
           uint32     version (0)
           uint32     DN format flags
           uint32     length of DN in bytes
           uint16+    DN
           uint8*     0 to 3 bytes for alignment to 32-bit boundary
           uint32     operation (0)
           uint32     number of IDs
           uint32*    ID, repeated for number of IDs

  Clear Event ID List

    Verb:
      `DSV_SET_REPLICATION_FILTER`

    Rights needed:
      Write access to the DirXML-AccessConfigure attribute on the target DirXML-Driver object.

    Wire format:

           uint32     DSVR_LOG_EVENTS (10)
           uint32     version (0)
           uint32     DN format flags
           uint32     length of DN in bytes
           uint16+    DN
           uint8*     0 to 3 bytes for alignment to 32-bit boundary
           uint32     operation (1)
           uint32     number of IDs (0)

  Notes:
    The event IDs are not Novell Audit event IDs. They are values defined in the `DxConst` class. In particular, they are those values whose names start with `LOG_EV_`.

  Availability:
    Identity Manager 2.0 onward.

  See Also:
    `constructSetLogEvents(java.lang.String,int[])`, `constructResetLogEvents(java.lang.String)`, `DxConst`, Constant Field Values

### DSVR_OPEN_DRIVER_ACTION

    public static final int DSVR_OPEN_DRIVER_ACTION

  Subverb used to send an XDS command or event document to a driver. Response is retrieved using the subverbs `DSVR_GET_CHUNKED_RESULT` and `DSVR_CLOSE_CHUNKED_RESULT`. Note that this bypasses the driver cache.

  Send XDS Document to Driver

    Verb:
      `DSV_SET_REPLICATION_FILTER`

    Rights needed:
      Write access to the DirXML-AccessSubmitCommand attribute on the target DirXML-Driver object.

    Wire format:

           uint32     DSVR_OPEN_DRIVER_ACTION (11)
           uint32     version (0 or 1)
           uint32     DN format flags
           uint32     length of driver DN in bytes
           uint16+    driver DN
           uint8*     0 to 3 bytes for alignment to 32-bit boundary
           uint32     timeout value in minutes (legal values 0-10)
           uint32     size in bytes of document data
           uint8*     XML document data

    Wire format of returned data:

           uint32     handle of result data
                      (use with DSVR_GET_CHUNKED_RESULT,
                       DSVR_CLOSE_CHUNKED_RESULT)
           uint32     total size of result data

  Notes:
    Version 0:
      Submits a command document. The submitted commands are processed by the Command Transformation, Schema Mapping, and Output Transformation rules.
    Version 1:
      Submits an event document. The submitted events are processed by the normal Subscriber channel rules, starting with the Filter and Event Transformation.
    The XML document data must be a well-formed, serialized XML document.

  Availability:
    Version 0: Identity Manager 2.0 onward
    Version 1: Identity Manager 3.5 onward

  See Also:
    `constructOpenDriverAction(java.lang.String,int,byte[])`, `constructOpenDriverAction(java.lang.String,int,byte[],int)`, `extractDriverActionResultHandle(byte[],int)`, `extractDriverActionResultSize(byte[],int)`, `DSVR_GET_CHUNKED_RESULT`, `DSVR_CLOSE_CHUNKED_RESULT`, Constant Field Values

### DSVR_GET_CHUNKED_RESULT

    public static final int DSVR_GET_CHUNKED_RESULT

  Subverb used to retrieve a result that may be very large.

  Get Part of Large Result

    Verb:
      `DSV_GET_REPLICATION_FILTER`

    Rights needed:
      The same rights that were needed for the verb that generated the results.

    Wire format:

           uint32     DSVR_GET_CHUNKED_RESULT (12)
           uint32     version (0)
           uint32     handle to data
           uint32     additional timeout value in minutes (valid values are 0-10)

    Wire format of returned data:

           uint32     size of data in bytes
           uint8*     data

Notes:
  The "handle to data" is that returned by the subverb that generated the results.
  Maximum data size to return is specified as normal for a DS verb.

Availability:
  Identity Manager 2.0 onward

See Also:
  `constructGetChunkedResult(int,int,int)`, `extractChunkedResultBytes(byte[],int)`, Constant Field Values

### DSVR_CLOSE_CHUNKED_RESULT

    public static final int DSVR_CLOSE_CHUNKED_RESULT

  Subverb used to release all resources associated with a "chunked" result.

  Release Large Result Resources

    Verb:
      `DSV_GET_REPLICATION_FILTER`

    Rights needed:
      The same rights that were needed for the verb that generated the results.

    Wire format:

           uint32     DSVR_CLOSE_CHUNKED_RESULT (13)
           uint32     version (0)
           uint32     handle to data

    Wire format of returned data:
      There is no data returned.

  Notes:
    The "handle to data" is that returned by the subverb that generated the results.

  Availability:
    Identity Manager 2.0 onward

  See Also:
    `constructCloseChunkedResult(int)`, Constant Field Values

### DSVR_GET_DIRXML_VERSION

    public static final int DSVR_GET_DIRXML_VERSION

  Subverb used to retrieve the DirXML Engine version number.

  Get DirXML Engine Version

    Verb:
      `DSV_GET_REPLICATION_FILTER`

    Rights needed:
      None.

    Wire format:

                uint32     DSVR_GET_DIRXML_VERSION (14)
                uint32     version (0)
                uint32     reserved

    Wire format of returned data:

           uint32     DirXML version number

  Notes:
    Format of version number is as follows:
    Bits 31-28 major version number
    Bits 27-24 minor version number
    Bits 23-16 patch or service pack level
    Bits 15-0 build number

    DirXML 1.x will return the error `-683` (`DSErr.ERR_INVALID_API_VERSION`) if this subverb is sent to a DirXML 1.x server.

  Availability:
    Identity Manager 2.0 onward

  See Also:
    `constructGetDirXMLVersion()`, `extractDirXMLVersion(byte[],int)`, `DxConst.parseDirXMLVersion(int)`, Constant Field Values

### DSVR_CHECK_OBJECT_PASSWORD

    public static final int DSVR_CHECK_OBJECT_PASSWORD

  Subverb used to perform a check password synchronization request on a specified object and driver. The eDirectory object's nspmDistributionPassword value is checked against the password of the corresponding object in the connected system.

  Check Password Synchronization

    Verb:
      `DSV_GET_REPLICATION_FILTER`

    Rights needed:
      The subverb issuer must have Manage Password rights to the target object, or must be authenticated as the target object.

      To check the password of the issuer's object, the issuer must have read access to the DirXML-AccessCheckObjectPassword attribute on the target DirXML-Driver object.

      To check the password of any object, the issuer must have write access to the DirXML-AccessCheckObjectPassword attribute on the target DirXML-Driver object.

    Wire format:

           uint32     DSVR_CHECK_OBJECT_PASSWORD (15)
           uint32     version (0)
           uint32     object DN format flags
           uint32     length of object DN in bytes
           uint16+    object DN
           uint8*     0 to 3 bytes for alignment to 32-bit boundary
           uint32     driver DN format flags
           uint32     length of driver DN in bytes
           uint16+    driver DN

    Wire format of returned data:

           uint32     result code

  Notes:
    The following result codes are of interest:
    `8019`
      The target object has no association value for the target driver.
    `9046`
      The password in the target system does not match the target object's Distribution Password. This can also indicate a problem retrieving the Distribution Password value.
    `9006`
      The driver shim returned a retry status. This indicates the shim could not connect to the connected system to check the password.
    Other
      Indicates an error of some sort.

    Manage Password rights means that the verb issuer has either write access to the ACL attribute on the target object or has write access to the Password Management attribute on the target object.

  Availability:
    Identity Manager 2.0 onward

  See Also:
    `constructCheckObjectPassword(java.lang.String,java.lang.String)`, Constant Field Values

### DSVR_INIT_DRIVER_OBJECT

    public static final int DSVR_INIT_DRIVER_OBJECT

  Subverb used to initialize any DirXML Engine-created values on a driver object. This is initially used for populating Engine Control Values.

  Initialize Driver Object

    Verb:
      `DSV_SET_REPLICATION_FILTER`

    Rights needed:
      Write access to the DirXML-AccessConfigure attribute on the target DirXML-Driver object.

    Wire format:

           uint32     DSVR_INIT_DRIVER_OBJECT (16)
           uint32     version (0)
           uint32     driver DN format flags
           uint32     length of driver DN in bytes
           uint16+    driver DN

    Wire format of returned data:
      There is no data returned.

  Availability:
    Identity Manager 2.0 onward

  See Also:
    `constructInitDriverObject(java.lang.String)`, Constant Field Values

### DSVR_NAMED_PASSWORD

    public static final int DSVR_NAMED_PASSWORD

  Subverb used to set and clear named passwords for an object.

  Deprecated. Set a Named Password w/o Display Name

    Verb:
      `DSV_SET_REPLICATION_FILTER`

    Rights needed:
      Write access to the DirXML-AccessConfigure attribute on the target object.

    Wire format:

           uint32     DSVR_NAMED_PASSWORD (17)
           uint32     version (0)
           uint32     DN format flags
           uint32     length of object DN in bytes
           uint16+    object DN
           uint8*     0 to 3 bytes for alignment to 32-bit boundary
           uint32     count of name data bytes
           uint8+     UTF-8 encoded name data bytes
           uint8*     0 to 3 bytes for alignment to 32-bit boundary
           uint32     size of password data bytes
           uint8*     UTF-8 encoded password data bytes

    Wire format of returned data:
      There is no data returned.

  Remove a Named Password

    Verb:
      `DSV_SET_REPLICATION_FILTER`

    Rights needed:
      Write access to the DirXML-AccessConfigure attribute on the target object.

    Wire format:

           uint32     DSVR_NAMED_PASSWORD (17)
           uint32     version (1)
           uint32     DN format flags
           uint32     length of object DN in bytes
           uint16+    object DN
           uint8*     0 to 3 bytes for alignment to 32-bit boundary
           uint32     count of name data bytes
           uint8+     UTF-8 encoded name data bytes

    Wire format of returned data:
      There is no data returned.

  Clear All Named Passwords

    Verb:
      `DSV_SET_REPLICATION_FILTER`

    Rights needed:
      Write access to the DirXML-AccessConfigure attribute on the target object.

    Wire format:

           uint32     DSVR_NAMED_PASSWORD (17)
           uint32     version (2)
           uint32     DN format flags
           uint32     length of object DN in bytes
           uint16+    object DN

    Wire format of returned data:
      There is no data returned.

  Deprecated. List Named Passwords w/o Display Names

    Verb:
      `DSV_SET_REPLICATION_FILTER`

    Rights needed:
      Read access to the DirXML-AccessConfigure attribute on the target object.

    Wire format:

           uint32     DSVR_NAMED_PASSWORD (17)
           uint32     version (3)
           uint32     DN format flags
           uint32     length of object DN in bytes
           uint16+    object DN

    Wire format of returned data:

           uint32         size required for list of named passwords
           uint32         count of named passwords
           for each UTF-8 string in count:
                uint32    count of UTF-8 bytes
                uint8+    UTF-encoded password name
                uint8*    0-3 bytes for 32-bit alignment

  Set a Named Password with Display Name

    Verb:
      `DSV_SET_REPLICATION_FILTER`

    Rights needed:
      Write access to the DirXML-AccessConfigure attribute on the target object.

    Wire format:

           uint32     DSVR_NAMED_PASSWORD (17)
           uint32     version (4 or 6)
           uint32     DN format flags
           uint32     length of object DN in bytes
           uint16+    object DN
           uint8*     0 to 3 bytes for alignment to 32-bit boundary
           uint32     count of name data bytes
           uint8+     UTF-8 encoded name data bytes
           uint8*     0 to 3 bytes for alignment to 32-bit boundary
           uint32     size of password data bytes (may be zero)
           uint8*     UTF-8 encoded password data bytes (if version 6, see notes)
           uint8*     0 to 3 bytes for alignment to 32-bit boundary
           uint32     count of display string data bytes (may be zero)
           uint8*     0 or more UTF-8 encoded display string data bytes

    Wire format of returned data:
      There is no data returned.

  List Named Passwords with Display Names

    Verb:
      `DSV_SET_REPLICATION_FILTER`

    Rights needed:
      Read access to the DirXML-AccessConfigure attribute on the target object.

    Wire format:

           uint32     DSVR_NAMED_PASSWORD (17)
           uint32     version (5)
           uint32     DN format flags
           uint32     length of object DN in bytes
           uint16+    object DN

    Wire format of returned data:

           uint32         size required for list of named passwords
           uint32         count of named passwords/display string pairs
           for each named password in count:
                uint32    count of UTF-8 bytes
                uint8+    UTF-8 encoded password name
                uint8*    0-3 bytes for 32-bit alignment
                uint32    count of UTF-8 bytes (may be zero)
                uint8*    UTF-8 encoded display string
                uint8*    0-3 bytes for 32-bit alignment

  Notes:
    Deprecated. Version 0:
      Name and password bytes are encoded in UTF-8. No terminating null is required, but is allowed.
    Version 1:
      Name bytes are encoded in UTF-8. No terminating null is required, but is allowed.
    Deprecated. Version 3:
      If the maximum return size is less than 8, `-649` (`DSErr.ERR_INSUFFICIENT_BUFFER`) is returned.

      If the maximum return size is greater than or equal to 8, but less than the total size required to return the complete list, only 8 bytes are returned: the size required and the count.

      If the maximum return size is greater than or equal to the size required then the full list is returned.
    Deprecated. Version 4:
      Name, password, and description bytes are encoded in UTF-8. No terminating null is required, but is allowed.
    Version 5:
      If the maximum return size is less than 8, `-649` (`DSErr.ERR_INSUFFICIENT_BUFFER`) is returned.

      If the maximum return size is greater than or equal to 8, but less than the total size required to return the complete list, only 8 bytes are returned: the size required and the count.

      If the maximum return size is greater than or equal to the size required then the full list is returned.
    Version 6
      Name and description bytes are encoded in UTF-8. No terminating null is required, but is allowed.

      The password data is encrypted using an RSA public key that is obtained using the `DSVR_GET_SERVER_CERT` subverb. The specific algorithm variant used is RSAES-OAEP with default parameters. In addition to the encrypted password data, the SHA-1 hash of the certificate bytes is sent to ensure that corresponding key pairs are used. The format, therefore, of the password data bytes shown above is as follows:

           uint8{20}  20 byte SHA-1 hash of the X.509 public key certificate
                      containing the public key used to encrypt the password data
           uint8*     RSAES-OAEP encrypted password data

  Notes on versions:
  Availability:
    Deprecated. Version 0: Identity Manager 2.0 onward.
    Version 1: Identity Manager 2.0 onward.
    Version 2: Identity Manager 2.0 onward.
    Deprecated. Version 3: Identity Manager 2.0 onward.
    Deprecated. Version 4: Identity Manager 2.0 onward.
    Version 5: Identity Manager 2.0 onward.
    Version 6: Identity Manager 3.0.1 onward

  See Also:
    `constructSetNamedPassword(java.lang.String,java.lang.String,java.lang.String)`, `constructSetNamedPassword(java.lang.String,java.lang.String,java.lang.String,java.lang.String)`, `constructSetNamedPassword(java.lang.String,java.lang.String,byte[],byte[],java.lang.String)`, `constructResetNamedPassword(java.lang.String,java.lang.String)`, `constructResetAllNamedPasswords(java.lang.String)`, `constructListNamedPasswords(java.lang.String,int)`, `constructListNamedPasswords_v5(java.lang.String,int)`, `extractNamedPasswordsSize(byte[],int)`, `extractNamedPasswordsCount(byte[],int)`, `extractPasswordName(byte[],int,int)`, `extractPasswordNameAndDesc(byte[],int,int)`, Constant Field Values

### DSVR_CACHE_UTIL

    public static final int DSVR_CACHE_UTIL

  Subverb used to view the contents of a stopped driver's cache, and to remove transaction records from the stopped driver's cache.

  View Driver Cache Contents

    Verb:
      `DSV_SET_REPLICATION_FILTER`

    Rights needed:
      Read access to the DirXML-AccessManage attribute on the target DirXML-Driver object.

    Wire format:

           uint32     DSVR_CACHE_UTIL (18)
           uint32     version (0)
           uint32     DN format flags
           uint32     length of driver DN in bytes
           uint16+    driver DN
           uint8*     0 to 3 bytes for alignment to 32-bit boundary
           uint32     timeout value in minutes (legal values 0-10)
           uint32     starting position token - 0 or value returned
                      from earlier call to version 0.
           uint32     maximum number of transactions to return (valid
                      values 1 through 0xffffffff)

    Wire format of returned data:

           uint32      handle of result data - use with DSVR_GET_CHUNKED_RESULT
                       and DSVR_CLOSE_CHUNKED_RESULT.
           uint32      total size of data available from DSVR_GET_CHUNKED_RESULT.
           uint32      new position token - may be used in subsequent calls
                       to version 0, or in calls to version 1

  Remove Transactions from Driver's Cache

    Verb:
      `DSV_SET_REPLICATION_FILTER`

    Rights needed:
      Write access to the DirXML-AccessManage attribute on the target DirXML-Driver object.

    Wire format:

           uint32     DSVR_CACHE_UTIL (18)
           uint32     version (1)
           uint32     DN format flags
           uint32     length of driver DN in bytes
           uint16+    driver DN
           uint8*     0 to 3 bytes for alignment to 32-bit boundary
           uint32     position token - 0 or value returned from version 0.
           uint32     count of transaction records to remove.
           uint32     count of UTF-8 encoded bytes (may be 0)
           uint8*     UTF-8 encoded event-id data bytes for starting transaction

    Wire format of returned data:
      None

  Notes:
    The position token must be either zero, or a value returned from a version 0 request. The position token represents the starting position in the cache from which to perform the requested operation.

    The driver must not be disabled, and driver must not be running.

    Version 0:
      The data returned are the bytes of a serialized XML document containing one or more transactions. If no data is available (i.e., the cache is empty) then the returned handle and data size are zero.

      An error code of `-641` (`DSErr.ERR_INVALID_REQUEST`) is returned if:
      - driver is disabled
      - driver is running
      - timeout value is invalid
      - position token or number of transactions is invalid

    Version 1:
      An error code of `-641` (`DSErr.ERR_INVALID_REQUEST`) is returned if:
      - driver is disabled
      - driver is running
      - position token or number of transactions is invalid

      `-602` (`DSErr.ERR_NO_SUCH_VALUE`) is returned if an event-id value is supplied and no transaction is found with the event-id value.

  Availability:
    Identity Manager 2.0 onward

  See Also:
    `constructReadDriverCache(java.lang.String,int,int,int)`, `extractReadDriverCacheResultHandle(byte[],int)`, `extractReadDriverCacheResultSize(byte[],int)`, `extractReadDriverCachePositionToken(byte[],int)`, `constructDeleteDriverCache(java.lang.String,int,int,java.lang.String)`, Constant Field Values

### DSVR_GET_PASSWORDS_STATE

    public static final int DSVR_GET_PASSWORDS_STATE

  Subverb used to determine if the following passwords are set for a driver.
  1. Application password.
  2. Remote Loader password.
  3. Driver Object password.

  Get Driver Passwords Status

    Verb:
      `DSV_GET_REPLICATION_FILTER`

    Rights needed:
      Read access to the DirXML-AccessConfigure attribute on the target DirXML-Driver object.

    Wire format:

           uint32     DSVR_GET_PASSWORDS_STATE (19)
           uint32     version (0)
           uint32     DN format flags
           uint32     length of driver DN in bytes
           uint16+    driver DN

    Wire format of returned data:

           uint32      bitmapped result:
                       bit 0     : if set, driver object password is set (Public/Private Key exists)
                       bit 1     : if set, application password is set
                       bit 2     : if set, remote loader password is set
                       bits 3-31 : reserved

  Availability:
    Identity Manager 3.0 onward

  See Also:
    `constructGetPasswordsState(java.lang.String)`, `extractGetPasswordsState(byte[],int)`, Constant Field Values

### DSVR_REMOTE_LOADER_PASSWORD

    public static final int DSVR_REMOTE_LOADER_PASSWORD

  Subverb used to set and clear the remote loader password for a driver.

  Set Remote Loader Password

    Verb:
      `DSV_SET_REPLICATION_FILTER`

    Rights needed:
      Write access to the DirXML-AccessConfigure attribute on the target DirXML-Driver object.

    Wire format:

           uint32     DSVR_REMOTE_LOADER_PASSWORD (20)
           uint32     version (0 or 2)
           uint32     DN format flags
           uint32     length of driver DN in bytes
           uint16+    driver DN
           uint8*     0 to 3 bytes for alignment to 32-bit boundary
           uint32     size of password data bytes
           uint8*     password data bytes (if version 2, see note)

    Wire format of returned data:
      There is no data returned.

  Clear Remote Loader Password

    Verb:
      `DSV_SET_REPLICATION_FILTER`

    Rights needed:
      Write access to the DirXML-AccessConfigure attribute on the target DirXML-Driver object.

    Wire format:

           uint32     DSVR_REMOTE_LOADER_PASSWORD (20)
           uint32     version (1)
           uint32     DN format flags
           uint32     length of driver DN in bytes
           uint16+    driver DN

    Wire format of returned data:
      There is no data returned.

  Notes
    Deprecated. Version 0:
      Password bytes are encoded in UTF-8. No terminating null is required, but is allowed.
    Version 2:
      Password data bytes are the UTF-8 encoding of the password characters, encrypted using an RSA public key that is obtained using the `DSVR_GET_SERVER_CERT` subverb. The specific algorithm variant used is RSAES-OAEP with default parameters. In addition to the encrypted password data, the SHA-1 hash of the certificate bytes is sent to ensure that corresponding key pairs are used. The format, therefore, of the password data bytes shown above is as follows:

           uint8{20}  20 byte SHA-1 hash of the X.509 public key certificate
                      containing the public key used to encrypt the password data
           uint8*     RSAES-OAEP encrypted password data

  Availability:
    Deprecated. Version 0: Identity Manager 3.0 onward
    Version 1: Identity Manager 3.0 onward
    Version 2: Identity Manager 3.0.1 onward

  See Also:
    `constructSetRemoteLoaderPassword(java.lang.String,java.lang.String)`, `constructSetRemoteLoaderPassword(java.lang.String,byte[],byte[])`, `constructResetRemoteLoaderPassword(java.lang.String)`, Constant Field Values

### DSVR_REGENERATE_KEY

    public static final int DSVR_REGENERATE_KEY

  Subverb used to cause a new public/private key pair to be generated for the DirXML server.

  Cause Key Pair Regeneration

    Verb:
      `DSV_SET_REPLICATION_FILTER`

    Rights needed:
      Supervisor rights to the NCP-Server object corresponding to the target server.

    Wire format:

           uint32     DSVR_REGENERATE_KEY (21)
           uint32     version (0)
           uint32     DN format flags (ignored)
           uint32     flag value of key pair to regenerate (e.g., 64 for RSA)

    Wire format of returned data:
      There is no data returned.

  Notes:
    The "flag" value specifies the Public Key algorithm. As of this writing, only RSA is supported, which has a value of 64.

  Availability:
    Version 0: Identity Manager 3.0.1 onward

  See Also:
    `constructRegenerateKey(int)`, Constant Field Values

### DSVR_GET_SERVER_CERT

    public static final int DSVR_GET_SERVER_CERT

  Subverb used to get the RSA Public Key certificate for the DirXML server.

  Get Server DirXML Public Key Certificate

    Verb:
      `DSV_GET_REPLICATION_FILTER`

    Rights needed:
      None.

    Wire format:

           uint32     DSVR_GET_SERVER_CERT (22)
           uint32     version (0)
           uint32     DN format flags (ignored)
           uint32     certificate format flag (0 for binary DER, 1 for base64-encoded DER)

    Wire format of returned data:

           uint8+     certificate data (size is entire response size)

  Availability:
    Identity Manager 3.0.1 onward

  See Also:
    `constructGetServerCert(int)`, `extractServerCert(byte[],int)`, Constant Field Values

### DSVR_DISCOVER_JOBS

    public static final int DSVR_DISCOVER_JOBS

  Subverb used to get the available job definitions on the server.

  Get Available Job Definitions

    Verb:
      `DSV_GET_REPLICATION_FILTER`

    Rights needed:
      Create rights in the container object specified.

    Wire format:

           uint32     DSVR_DISCOVER_JOBS (23)
           uint32     version (0 or 1)
           uint32     DN format flags
           uint32     length of driver or driver set DN in bytes
           uint16+    driver or driver set DN
           uint8*     0 to 3 bytes for alignment to 32-bit boundary
           uint32     timeout value in minutes (legal values 0-10)

    Wire format of returned data:

           uint32     handle of result data
                      (use with DSVR_GET_CHUNKED_RESULT,
                       DSVR_CLOSE_CHUNKED_RESULT)
           uint32     total size of result data

  Notes:
    Version 0:
      Returned job definitions are filtered by containment type (e.g., if a DirXML-Driver object is specified then only definitions for jobs that can be contained by a DirXML-Driver object are returned).
    Version 1:
      Returned job definitions are not filtered.

  Availability:
    Identity Manager 3.5 onward

  See Also:
    `constructDiscoverJobs(java.lang.String,int)`, `constructDiscoverAllJobs(java.lang.String,int)`, Constant Field Values

### DSVR_NOTIFY_JOB_UPDATE

    public static final int DSVR_NOTIFY_JOB_UPDATE

  Notify the DirXML Engine that the data associated with a DirXML-Job object has changed. This verb should be issued by a user agent after an editing session on the DirXML-Job object data has been completed.

  Notify Engine of Job Configuration Change

    Verb:
      `DSV_SET_REPLICATION_FILTER`

    Rights needed:
      Write access to the DirXML-AccessConfigure attribute on the target DirXML-Job object.

    Wire format:

           uint32     DSVR_NOTIFY_JOB_UPDATE (24)
           uint32     version (0)
           uint32     DN format flags
           uint32     length of DirXML-Job object DN in bytes
           uint16+    DirXML-Job object DN

    Wire format of returned data:
      There is no data returned.

  Availability:
    Identity Manager 3.5 onward

  See Also:
    `constructNotifyJobUpdate(java.lang.String)`, Constant Field Values

### DSVR_START_JOB

    public static final int DSVR_START_JOB

  Subverb used to manually start a DirXML job if the job is enabled and not already running.

  Start a Job

    Verb:
      `DSV_SET_REPLICATION_FILTER`

    Rights needed:
      Write access to the DirXML-AccessRun attribute on the target DirXML-Job object.

    Wire format:

           uint32     DSVR_START_JOB (25)
           uint32     version (0)
           uint32     DN format flags
           uint32     length of DirXML-Job object DN in bytes
           uint16+    DirXML-Job object DN

    Wire format of returned data:
      There is no data returned.

    Notes:
      Return Codes:
      `-601` (`DSErr.ERR_NO_SUCH_ENTRY`)
        There is no DirXML-Job object as specified by DN
      `-672` (`DSErr.ERR_NO_ACCESS`)
        Insufficient rights to start job
      `-641` (`DSErr.ERR_INVALID_REQUEST`)
        The job is disabled, has an invalid configuration, or is already running

  Availability:
    Identity Manager 3.5 onward

  See Also:
    `constructStartJob(java.lang.String)`, Constant Field Values

### DSVR_ABORT_JOB

    public static final int DSVR_ABORT_JOB

  Subverb used to abort a DirXML job if the job is running.

  Abort a Job

    Verb:
      `DSV_SET_REPLICATION_FILTER`

    Rights needed:
      Write access to the DirXML-AccessRun attribute on the target DirXML-Job object.

    Wire format:

           uint32     DSVR_ABORT_JOB (26)
           uint32     version (0)
           uint32     DN format flags
           uint32     length of DirXML-Job object DN in bytes
           uint16+    DirXML-Job object DN

    Wire format of returned data:
      There is no data returned.

    Notes:
      Return Codes:
      `-601` (`DSErr.ERR_NO_SUCH_ENTRY`)
        There is no DirXML-Job object as specified by DN
      `-672` (`DSErr.ERR_NO_ACCESS`)
        Insufficient rights to abort job
      `-641` (`DSErr.ERR_INVALID_REQUEST`)
        The job is disabled, has an invalid configuration, or is already stopped

  Availability:
    Identity Manager 3.5 onward

  See Also:
    `constructAbortJob(java.lang.String)`, Constant Field Values

### DSVR_GET_JOB_STATE

    public static final int DSVR_GET_JOB_STATE

  Subverb used to get the current running state and next run time of a DirXML job.

  Get Job State

    Verb:
      `DSV_GET_REPLICATION_FILTER`

    Rights needed:
      Read access to the DirXML-AccessConfigure attribute on the target DirXML-Job object.

    Wire format:

           uint32     DSVR_GET_JOB_STATE (27)
           uint32     version (0)
           uint32     DN format flags
           uint32     length of DirXML-Job object DN in bytes
           uint16+    DirXML-Job object DN

    Wire format of returned data:

           uint32     size of following data (12)
           uint32     running state (0 = stopped, 1 = running)
           uint32     configuration state (0 = disabled, 1 = enabled, 2 = configuration error)
           uint32     next scheduled run time (0 = not scheduled, otherwise is next scheduled time in eDirectory TIME format)

    Notes:
      Return Codes:
      `-601` (`DSErr.ERR_NO_SUCH_ENTRY`)
        There is no DirXML-Job object as specified by DN.
      `-672` (`DSErr.ERR_NO_ACCESS`)
        Insufficient rights to get state.
      `-641` (`DSErr.ERR_INVALID_REQUEST`)
        The job is disabled, has an invalid configuration, or is already stopped.

      Use `DSV_CHECK_JOB_CONFIG` to get a more complete and useful view of a job's configuration state.

  Availability:
    Identity Manager 3.5 onward

  See Also:
    `constructGetJobState(java.lang.String)`, `extractJobRunningState(byte[],int)`, `extractJobConfigState(byte[],int)`, `extractJobNextTime(byte[],int)`, Constant Field Values

### DSVR_QUEUE_EVENT

    public static final int DSVR_QUEUE_EVENT

  Subverb used to cache an arbitrary event document for the driver.

  Get Job State

    Verb:
      `DSV_SET_REPLICATION_FILTER`

    Rights needed:
      Write access to the DirXML-AccessSubmitCommand attribute on the target DirXML-Job object.

    Wire format:

           uint32     DSVR_QUEUE_EVENT (28)
           uint32     version (0)
           uint32     DN format flags
           uint32     length of driver DN in bytes
           uint16+    driver DN
           uint8*     0 to 3 bytes for alignment to 32-bit boundary
           uint32     size of event document data in bytes
           uint8*     event document data

    Wire format of returned data:
      There is no data returned.

  Availability:
    Identity Manager 3.5 onward

  See Also:
    `constructQueueEvent(java.lang.String,byte[])`, Constant Field Values

### DSVR_CHECK_JOB_CONFIG

    public static final int DSVR_CHECK_JOB_CONFIG

  Subverb used to check a DirXML-Job object's configuration.

  Get Job State

    Verb:
      `DSV_GET_REPLICATION_FILTER`

    Rights needed:
      Read access to the DirXML-AccessConfigure attribute on the target DirXML-Job object.

    Wire format:

           uint32     DSVR_CHECK_JOB_CONFIG (29)
           uint32     version (0)
           uint32     DN format flags
           uint32     length of job DN in bytes
           uint16+    driver DN
           uint8*     0 to 3 bytes for alignment to 32-bit boundary
           uint32     length of language code string (0 or 4)
           uint16*    0 or 2 UTF-16 chars (e.g., 'E' 'N')
           uint32     length of country code string (0 or 4)
           uint16*    0 or 2 UTF-16 chars (e.g., 'U' 'S')
           uint32     timeout value in minutes (legal values 0-10)

    Wire format of returned data:

           uint32     handle of result data
                      (use with DSVR_GET_CHUNKED_RESULT,
                       DSVR_CLOSE_CHUNKED_RESULT)
           uint32     total size of result data

    Notes:
      The language and country codes are used to localize messages in the data returned via `DSVR_GET_CHUNKED_RESULT`. If the country code appears then the language code must appear; otherwise it is an error.

      The data returned via `DSVR_GET_CHUNKED_RESULT` is a serialized XML document containing information about any configuration warnings or errors.

Availability:
  Identity Manager 3.5 onward

See Also:
  `constructCheckJobConfig(java.lang.String,java.lang.String,java.lang.String,int)`, Constant Field Values

Constructor Detail

### DxWire

    public DxWire()

  Construct an instance of DxWire that can be used to construct wire-format buffers.

  This sets the dn format flags to the default of:

       DSWire.DS_INFO_TYPELESS_OUTPUT | DSWire.DS_INFO_SLASH_OUTPUT

  See Also:
    `DSWire`

### DxWire

    public DxWire(int dnFormatFlags)

  Construct an instance of DxWire that can be used to construct wire-format buffers.

  Parameters:
    `dnFormatFlags` - some combination of the DSWire.DS_INFO_* bit flags.
  See Also:
    `DSWire`

Method Detail

### setDnFormat

    public void setDnFormat(int dnFormat)

  Set the DN format based on an XdsDN format number.

  Parameters:
    `dnFormat` - XdsDN.SLASH_FORM, XdsDN.QSLASH_FORM, XdsDN.DOT_FORM, XdsDN.QDOT_FORM

### setDnFormatFlags

    public void setDnFormatFlags(int dnFormatFlags)

  Set the DN format flags used with this instance.

  Parameters:
    `dnFormatFlags` - some combination of the DSWire.DS_INFO_* bit flags.

### getDnFormatFlags

    public int getDnFormatFlags()

  Return the DN format flags used with this instance.

  Returns:
    DN format flags.
  See Also:
    `DSWire`

### constructSetDriverState

    public DxWire.DxWireData constructSetDriverState(String driverDN,
                                                     int newState)

  Construct a wire-format buffer to set a DirXML driver's state.

  Parameters:
    `driverDN` - DN of driver whose state is to be set.
    `newState` - `DxConst.VR_DRIVER_STARTING`, `DxConst.VR_DRIVER_SHUTDOWN_PENDING`, or `DxConst.VR_DRIVER_GET_SCHEMA` (not checked).
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_DRIVER_STATE`

### constructGetDriverState

    public DxWire.DxWireData constructGetDriverState(String driverDN)

  Construct a wire-format buffer to get a DirXML driver's state.

  Parameters:
    `driverDN` - DN of driver whose state is to be retrieved.
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_DRIVER_STATE`, `extractDriverState(byte[],int)`

### extractDriverState

    public int extractDriverState(byte[] verbResponseData,
                                  int responseSize)

  Extract the state value returned as a result of `DSV_GET_REPLICATION_FILTER` with `DSVR_DRIVER_STATE`.

  Parameters:
    `verbResponseData` - data returned as a result of the DS verb request.
    `responseSize` - size of value data in `verbResponseData` array.
  Returns:
    state value.
  See Also:
    `DSVR_DRIVER_STATE`

### constructOpenDriverAction

    public DxWire.DxWireData constructOpenDriverAction(String driverDN,
                                                       int timeoutPeriod,
                                                       byte[] xdsDocumentBytes)

  Construct a wire-format buffer to send an XDS command document to a DirXML driver.

  Parameters:
    `driverDN` - DN of driver to which the command document is to be sent.
    `timeoutPeriod` - timeout period, in minutes for result data. 0-10 are valid values, but value is not checked. 0 means use the default.
    `xdsDocumentBytes` - bytes containing serialized XML document.
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_OPEN_DRIVER_ACTION`, `extractDriverActionResultHandle(byte[],int)`, `extractDriverActionResultSize(byte[],int)`

### constructOpenDriverAction

    public DxWire.DxWireData constructOpenDriverAction(String driverDN,
                                                       int timeoutPeriod,
                                                       byte[] xdsDocumentBytes,
                                                       int version)

  Construct a wire-format buffer to send an XDS command document to a DirXML driver.

  Parameters:
    `driverDN` - DN of driver to which the command document is to be sent.
    `timeoutPeriod` - timeout period, in minutes for result data. 0-10 are valid values, but value is not checked. 0 means use the default.
    `xdsDocumentBytes` - bytes containing serialized XML document.
    `version` - subverb version flag
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_OPEN_DRIVER_ACTION`, `extractDriverActionResultHandle(byte[],int)`, `extractDriverActionResultSize(byte[],int)`

### extractDriverActionResultHandle

    public int extractDriverActionResultHandle(byte[] verbResponseData,
                                               int responseSize)

  Extract the result data handle from the wire data returned as a result of `DSV_SET_REPLICATION_FILTER` with `DSVR_OPEN_DRIVER_ACTION`.

  Parameters:
    `verbResponseData` - data returned as a result of the DS verb request.
    `responseSize` - size of value data in `verbResponseData` array.
  Returns:
    handle to result data
  See Also:
    `DSVR_OPEN_DRIVER_ACTION`, `constructOpenDriverAction(java.lang.String,int,byte[])`, `constructGetChunkedResult(int,int,int)`, `constructCloseChunkedResult(int)`

### extractDriverActionResultSize

    public int extractDriverActionResultSize(byte[] verbResponseData,
                                             int responseSize)

  Extract the result data size from the wire data returned as a result of `DSV_SET_REPLICATION_FILTER` with `DSVR_OPEN_DRIVER_ACTION`.

  Parameters:
    `verbResponseData` - data returned as a result of the DS verb request.
    `responseSize` - size of value data in `verbResponseData` array.
  Returns:
    total size of result data
  See Also:
    `DSVR_OPEN_DRIVER_ACTION`, `constructOpenDriverAction(java.lang.String,int,byte[])`, `constructGetChunkedResult(int,int,int)`

### constructGetChunkedResult

    public DxWire.DxWireData constructGetChunkedResult(int handle,
                                                       int additionalTimeout,
                                                       int maxResponseSize)

  Construct a wire-format buffer to retrieve data available using the `DSVR_GET_CHUNKED_RESULT` subverb.

  Parameters:
    `handle` - handle to available data
    `additionalTimeout` - additional timeout value, in minutes, for result data. 0-10 are valid values, but value is not checked.
    `maxResponseSize` - maximum size of data to return as a result of this verb request.
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_GET_CHUNKED_RESULT`, `constructCloseChunkedResult(int)`

### extractChunkedResultBytes

    public byte[] extractChunkedResultBytes(byte[] verbResponseData,
                                            int responseSize)

  Extract the result data from the wire data returned as a result of `DSV_GET_REPLICATION_FILTER` with `DSVR_GET_RESULT_CHUNK`.

  Parameters:
    `verbResponseData` - data returned as a result of the DS verb request.
    `responseSize` - size of value data in `verbResponseData` array.
  Returns:
    data bytes from wire buffer.
  See Also:
    `constructGetChunkedResult(int,int,int)`

### constructCloseChunkedResult

    public DxWire.DxWireData constructCloseChunkedResult(int handle)

  Construct a wire-format buffer to retrieve data available using the `DSVR_CLOSE_CHUNKED_RESULT` subverb.

  Parameters:
    `handle` - handle to data
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_CLOSE_CHUNKED_RESULT`, `constructGetChunkedResult(int,int,int)`

### constructGetDriverSet

    public DxWire.DxWireData constructGetDriverSet()

  Construct a wire-format buffer to get the DN of the DirXML-DriverSet object associated with a server.

  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_DRIVER_SET`, `extractDriverSetDN(byte[],int)`

### constructSetDriverSet

    public DxWire.DxWireData constructSetDriverSet(String driverSetDN)

  Construct a wire-format buffer to associate a DirXML-DriverSet object with a server.

  Parameters:
    `driverSetDN` - DN of DirXML-DriverSet object.
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_DRIVER_SET`

### constructResetDriverSet

    public DxWire.DxWireData constructResetDriverSet()

  Construct a wire-format buffer to associate from a server the currently associated DirXML-DriverSet object.

  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_DRIVER_SET`

### extractDriverSetDN

    public String extractDriverSetDN(byte[] verbResponseData,
                                     int responseSize)

  Extract the DN from the wire data returned as a result of `DSV_GET_REPLICATION_FILTER` with `DSVR_DRIVER_SET`.

  Parameters:
    `verbResponseData` - data returned as a result of the DS verb request.
    `responseSize` - size of value data in `verbResponseData` array.
  Returns:
    DN value from wire buffer.
  See Also:
    `DSVR_DRIVER_SET`, `constructGetDriverSet()`

### constructGetDriverStartOption

    public DxWire.DxWireData constructGetDriverStartOption(String driverDN)

  Construct a wire-format buffer to get a DirXML driver's start up option.

  Parameters:
    `driverDN` - DN of driver whose option is to be retrieved.
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_DRIVER_START_OPTION`, `extractDriverStartOption(byte[],int)`

### extractDriverStartOption

    public int extractDriverStartOption(byte[] verbResponseData,
                                        int responseSize)

  Extract the sdriver start up option value returned as a result of `DSV_GET_REPLICATION_FILTER` with `DSVR_DRIVER_START_OPTION`.

  Parameters:
    `verbResponseData` - data returned as a result of the DS verb request.
    `responseSize` - size of value data in `verbResponseData` array.
  Returns:
    start up option value.
  See Also:
    `DSVR_DRIVER_START_OPTION`

### constructSetDriverStartOption

    public DxWire.DxWireData constructSetDriverStartOption(String driverDN,
                                                           int newStartOption,
                                                           boolean noResync)

  Construct a wire-format buffer to set a DirXML driver's start option.

  Parameters:
    `driverDN` - DN of driver whose option is to be set.
    `newStartOption` - `DxConst.VR_DRIVER_DISABLED`, `DxConst.VR_DRIVER_MANUAL_START`, or `DxConst.VR_DRIVER_AUTO_START` (not checked).
    `noResync` - if `true`, causes version number of 1 to be put in wire buffer. This may only be set to `true` for Identity Manager 2 and later.
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_DRIVER_START_OPTION`

### constructResyncDriver

    public DxWire.DxWireData constructResyncDriver(String driverDN)

  Construct a wire-format buffer to cause a manual resync of a DirXML driver's state.

  Parameters:
    `driverDN` - DN of driver to be resync'd.
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_RESYNC_DRIVER`

### constructResyncDriver

    public DxWire.DxWireData constructResyncDriver(String driverDN,
                                                   int seconds)

  Construct a wire-format buffer to cause a manual resync of a DirXML driver's state.

  Parameters:
    `driverDN` - DN of driver to be resync'd.
    `seconds` - starting time for resync
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_RESYNC_DRIVER`

### constructSetDriverCacheLimit

    public DxWire.DxWireData constructSetDriverCacheLimit(String driverDN,
                                                          int newLimit)

  Deprecated.

  Construct a wire-format buffer to set a DirXML driver's cache size limit.

  Parameters:
    `driverDN` - DN of driver whose cache size limit is to be set.
    `newLimit` - 0, or size in kilobytes.
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_DRIVER_CACHE_LIMIT`

### constructGetDriverCacheLimit

    public DxWire.DxWireData constructGetDriverCacheLimit(String driverDN)

  Deprecated.

  Construct a wire-format buffer to get a DirXML driver's cache size limit.

  Parameters:
    `driverDN` - DN of driver whose cache limit value is to be retrieved.
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_DRIVER_CACHE_LIMIT`, `extractDriverCacheLimit(byte[],int)`

### extractDriverCacheLimit

    public int extractDriverCacheLimit(byte[] verbResponseData,
                                       int responseSize)

  Deprecated.

  Extract the cache size limit value returned as a result of `DSV_GET_REPLICATION_FILTER` with `DSVR_DRIVER_CACHE_LIMIT`.

  Parameters:
    `verbResponseData` - data returned as a result of the DS verb request.
    `responseSize` - size of value data in `verbResponseData` array.
  Returns:
    cache limit
  See Also:
    `DSVR_DRIVER_CACHE_LIMIT`

### constructMigrateApp

    public DxWire.DxWireData constructMigrateApp(String driverDN,
                                                 byte[] xdsDocumentBytes)

  Construct a wire-format buffer to send an query document to a DirXML driver to cause the engine to migrate all objects returned as the result of the query into DirXML.

  Parameters:
    `driverDN` - DN of driver to which the query document is to be sent.
    `xdsDocumentBytes` - bytes containing serialized XML document.
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_MIGRATE_APP`

### constructQueueEvent

    public DxWire.DxWireData constructQueueEvent(String driverDN,
                                                 byte[] xdsDocumentBytes)

  Construct a wire-format buffer to send an query document to a DirXML driver to cause the engine to migrate all objects returned as the result of the query into DirXML.

  Parameters:
    `driverDN` - DN of driver to which the query document is to be sent.
    `xdsDocumentBytes` - bytes containing serialized XML document.
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_QUEUE_EVENT`

### constructSetShimPassword

    public DxWire.DxWireData constructSetShimPassword(String driverDN,
                                                      String password,
                                                      boolean dirXML_1x)

  Deprecated.

  Construct a wire-format buffer to set the shim password for a DirXML driver.

  Parameters:
    `driverDN` - DN of driver whose shim password value is to be set.
    `password` - password value to set.
    `dirXML_1x` - set to `true` if this request is for DirXML 1.x.
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_SHIM_PASSWORD`

### constructSetAppPassword

    public DxWire.DxWireData constructSetAppPassword(String driverDN,
                                                     String password)

  Deprecated.

  Construct a wire-format buffer to set the shim password for a DirXML driver.

  Parameters:
    `driverDN` - DN of driver whose shim password value is to be set.
    `password` - password value to set.
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_SHIM_PASSWORD`

### constructSetAppPassword

    public DxWire.DxWireData constructSetAppPassword(String driverDN,
                                                     byte[] encryptedPassword,
                                                     byte[] certHash)

  Construct a wire-format buffer to set the shim password for a DirXML driver using the "send-encrypted" form.

  Parameters:
    `driverDN` - DN of driver whose shim password value is to be set.
    `encryptedPassword` - encrypted bytes of UTF-8 encoded password bytes that have been encrypted using the RSA public key for the server to which the password is to be set. The encryption algorithm must be RSAES-OAEP with default parameters.
    `certHash` - the 20-byte SHA-1 hash of the public key certificate used for encrypting the password bytes
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_SHIM_PASSWORD`

### constructResetShimPassword

    public DxWire.DxWireData constructResetShimPassword(String driverDN)

  Deprecated.

  Construct a wire-format buffer to clear the shim password for a DirXML driver.

  Parameters:
    `driverDN` - DN of driver whose shim password value is to be cleared.
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_SHIM_PASSWORD`

### constructResetAppPassword

    public DxWire.DxWireData constructResetAppPassword(String driverDN)

  Construct a wire-format buffer to clear the shim password for a DirXML driver.

  Parameters:
    `driverDN` - DN of driver whose shim password value is to be cleared.
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_SHIM_PASSWORD`

### constructSetRemoteLoaderPassword

    public DxWire.DxWireData constructSetRemoteLoaderPassword(String driverDN,
                                                              String password)

  Deprecated.

  Construct a wire-format buffer to set the Remote Loader password for a DirXML driver.

  Parameters:
    `driverDN` - DN of driver whose Remote Loader password value is to be set.
    `password` - password value to set.
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_REMOTE_LOADER_PASSWORD`

### constructSetRemoteLoaderPassword

    public DxWire.DxWireData constructSetRemoteLoaderPassword(String driverDN,
                                                              byte[] encryptedPassword,
                                                              byte[] certHash)

  Construct a wire-format buffer to set the Remote Loader password for a DirXML driver.

  Parameters:
    `driverDN` - DN of driver whose Remote Loader password value is to be set.
    `encryptedPassword` - encrypted bytes of UTF-8 encoded password bytes that have been encrypted using the RSA public key for the server to which the password is to be set. The encryption algorithm must be RSAES-OAEP with default parameters.
    `certHash` - the 20-byte SHA-1 hash of the public key certificate used for encrypting the password bytes
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_REMOTE_LOADER_PASSWORD`

### constructResetRemoteLoaderPassword

    public DxWire.DxWireData constructResetRemoteLoaderPassword(String driverDN)

  Construct a wire-format buffer to clear the Remote Loader password for a DirXML driver.

  Parameters:
    `driverDN` - DN of driver whose Remote Loader password value is to be cleared.
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_REMOTE_LOADER_PASSWORD`

### constructGetDirXMLVersion

    public DxWire.DxWireData constructGetDirXMLVersion()

  Construct a wire-format buffer to get the DirXML version on a server.

  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_GET_DIRXML_VERSION`, `extractDirXMLVersion(byte[],int)`

### extractDirXMLVersion

    public int extractDirXMLVersion(byte[] verbResponseData,
                                    int responseSize)

  Extract the version value returned as a result of `DSV_GET_REPLICATION_FILTER` with `DSVR_GET_DIRXML_VERSION`.

  Parameters:
    `verbResponseData` - data returned as a result of the DS verb request.
    `responseSize` - size of value data in `verbResponseData` array.
  Returns:
    version number
  See Also:
    `DSVR_GET_DIRXML_VERSION`, `DxConst.parseDirXMLVersion(int)`

### constructSetLogEvents

    public DxWire.DxWireData constructSetLogEvents(String objectDN,
                                                   int[] eventIDs)

  Construct a wire-format buffer to set the list of event IDs to be logged on a DirXML-DriverSet or DirXML-Driver object.

  Parameters:
    `objectDN` - DN of DirXML-DriverSet or DirXML-Driver object.
    `eventIDs` - array of event ID values.
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_LOG_EVENTS`, `DxConst`

### constructResetLogEvents

    public DxWire.DxWireData constructResetLogEvents(String objectDN)

  Construct a wire-format buffer to clear the list of event IDs to be logged on a DirXML-DriverSet or DirXML-Driver object.

  Parameters:
    `objectDN` - DN of DirXML-DriverSet or DirXML-Driver object.
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_LOG_EVENTS`

### constructCheckObjectPassword

    public DxWire.DxWireData constructCheckObjectPassword(String objectDN,
                                                          String driverDN)

  Construct a wire-format buffer to perform a check object password command for a specific user and DirXML driver.

  Parameters:
    `objectDN` - DN of object to perform a check object password request
    `driverDN` - DN of driver to which the command document is to be sent.
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_CHECK_OBJECT_PASSWORD`, `extractDriverActionResultHandle(byte[],int)`, `extractDriverActionResultSize(byte[],int)`

### extractCheckObjectPasswordResult

    public int extractCheckObjectPasswordResult(byte[] verbResponseData,
                                                int responseSize)

  Extract the result data from the wire data returned as a result of `DSV_SET_REPLICATION_FILTER` with `DSVR_CHECK_OBJECT_PASSWORD`.

  Parameters:
    `verbResponseData` - data returned as a result of the DS verb request.
    `responseSize` - size of value data in `verbResponseData` array.
  Returns:
    result of check object password
  See Also:
    `DSVR_CHECK_OBJECT_PASSWORD`, `constructCheckObjectPassword(java.lang.String,java.lang.String)`

### constructInitDriverObject

    public DxWire.DxWireData constructInitDriverObject(String driverDN)

  Construct a wire-format buffer to perform a driver object init on a new driver object.

  Parameters:
    `driverDN` - DN of driver object to be initialized.
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_INIT_DRIVER_OBJECT`

### constructSetNamedPassword

    public DxWire.DxWireData constructSetNamedPassword(String driverDN,
                                                       String key,
                                                       String password)

  Deprecated.

  Construct a wire-format buffer to set a named password for a DirXML driver.

  Parameters:
    `driverDN` - DN of driver for which the named password value is to be set.
    `key` - The key value (name) of the password value.
    `password` - The password value to set.
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_NAMED_PASSWORD`

### constructSetNamedPassword

    public DxWire.DxWireData constructSetNamedPassword(String driverDN,
                                                       String key,
                                                       String password,
                                                       String description)

  Deprecated.

  Construct a wire-format buffer to set a named password for a DirXML driver.

  Parameters:
    `driverDN` - DN of driver for which the named password value is to be set.
    `key` - The key value (name) of the password value.
    `password` - The password value to set.
    `description` - Description string for named password.
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_NAMED_PASSWORD`

### constructSetNamedPassword

    public DxWire.DxWireData constructSetNamedPassword(String driverDN,
                                                       String key,
                                                       byte[] encryptedPassword,
                                                       byte[] certHash,
                                                       String description)

  Construct a wire-format buffer to set a named password for a DirXML driver, with encrypted password bytes.

  Parameters:
    `driverDN` - DN of driver for which the named password value is to be set.
    `key` - The key value (name) of the password value.
    `encryptedPassword` - encrypted bytes of UTF-8 encoded password bytes that have been encrypted using the RSA public key for the server to which the password is to be set. The encryption algorithm must be RSAES-OAEP with default parameters.
    `certHash` - the 20-byte SHA-1 hash of the public key certificate used for encrypting the password bytes
    `description` - Description string for named password.
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_NAMED_PASSWORD`

### constructResetNamedPassword

    public DxWire.DxWireData constructResetNamedPassword(String driverDN,
                                                         String key)

  Construct a wire-format buffer to clear a named password for a DirXML driver.

  Parameters:
    `driverDN` - DN of driver for which the named password value is to be cleared.
    `key` - The key value (name) of the password value.
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_NAMED_PASSWORD`

### constructResetAllNamedPasswords

    public DxWire.DxWireData constructResetAllNamedPasswords(String driverDN)

  Construct a wire-format buffer to clear all named passwords for a DirXML driver.

  Parameters:
    `driverDN` - DN of driver for which the named password value is to be cleared.
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_NAMED_PASSWORD`

### constructListNamedPasswords

    public DxWire.DxWireData constructListNamedPasswords(String driverDN,
                                                         int maxResponseSize)

  Deprecated.

  Construct a wire-format buffer to return a list of named passwords for a DirXML driver.

  Parameters:
    `driverDN` - DN of driver for which the named password value is to be cleared.
    `maxResponseSize` - maximum size to allocate for response buffer.
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_NAMED_PASSWORD`

### constructListNamedPasswords_v5

    public DxWire.DxWireData constructListNamedPasswords_v5(String driverDN,
                                                            int maxResponseSize)

  Construct a wire-format buffer to return a list of named passwords and their description strings for a DirXML driver.

  Parameters:
    `driverDN` - DN of driver for which the named password value is to be cleared.
    `maxResponseSize` - maximum size to allocate for response buffer.
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_NAMED_PASSWORD`

### extractNamedPasswordsSize

    public int extractNamedPasswordsSize(byte[] verbResponseData,
                                         int responseSize)

  Extract the total size required for the return data from `DSV_SET_REPLICATION_FILTER` with `DSVR_NAMED_PASSWORD`, version 3. This is useful if you need to know how big a buffer to allocate before actually getting the data. Use constructListNamedPasswords() with a maxResponseSize == 0 and the only data returned will be the size required and the count of named passwords.

  Parameters:
    `verbResponseData` - data returned as a result of the DS verb request.
    `responseSize` - size of value data in `verbResponseData` array.
  Returns:
    total size in bytes required
  See Also:
    `DSVR_NAMED_PASSWORD`, `constructCheckObjectPassword(java.lang.String,java.lang.String)`

### extractNamedPasswordsCount

    public int extractNamedPasswordsCount(byte[] verbResponseData,
                                          int responseSize)

  Extract the count of password keys (version 3) or password key/description pairs (version 5) from the return data from `DSV_SET_REPLICATION_FILTER` with `DSVR_NAMED_PASSWORD`, version 3 or 5.

  Parameters:
    `verbResponseData` - data returned as a result of the DS verb request.
    `responseSize` - size of value data in `verbResponseData` array.
  Returns:
    count of named passwords
  See Also:
    `DSVR_NAMED_PASSWORD`, `constructCheckObjectPassword(java.lang.String,java.lang.String)`

### extractPasswordName

    public String extractPasswordName(byte[] verbResponseData,
                                      int responseSize,
                                      int keyIndex)

  Deprecated.

  Extract a password key (name) from the return data from `DSV_SET_REPLICATION_FILTER` with `DSVR_NAMED_PASSWORD`, version 3.

  This must only be used with the return from version 3.

  Passing an invalid index will return null.

  Parameters:
    `verbResponseData` - data returned as a result of the DS verb request.
    `responseSize` - size of value data in `verbResponseData` array.
    `keyIndex` - index of the password key to return.
  Returns:
    String containing password key, or null if keyIndex is out-of-range.

### extractPasswordNameAndDesc

    public String[] extractPasswordNameAndDesc(byte[] verbResponseData,
                                               int responseSize,
                                               int keyIndex)

  Extract a password key (name) and description from the return data from `DSV_SET_REPLICATION_FILTER` with `DSVR_NAMED_PASSWORD`, version 5.

  This must only be used with the return from version 5.

  Passing an invalid index will return `null`.

  Parameters:
    `verbResponseData` - data returned as a result of the DS verb request.
    `responseSize` - size of value data in `verbResponseData` array.
    `keyIndex` - index of the password key to return.
  Returns:
    2-element `String` array containing password key and description at index `0` and `1`, respectively. `null` if keyIndex is out-of-range.

### constructReadDriverCache

    public DxWire.DxWireData constructReadDriverCache(String driverDN,
                                                      int timeoutPeriod,
                                                      int positionToken,
                                                      int maxTransactions)

  Construct a wire-format buffer to send a DSVR_CACHE_UTIL version 0 request to a DirXML driver.

  Parameters:
    `driverDN` - DN of driver whose cache is to be read.
    `timeoutPeriod` - timeout period, in minutes for result data. 0-10 are valid values, but value is not checked. 0 means use the default.
    `positionToken` - 0 or value returned from earlier DSVR_CACHE_UTIL version 0 request.
    `maxTransactions` - maximum transactions to read and return.
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_CACHE_UTIL`, `extractReadDriverCacheResultHandle(byte[],int)`, `extractReadDriverCacheResultSize(byte[],int)`, `extractReadDriverCachePositionToken(byte[],int)`

### extractReadDriverCacheResultHandle

    public int extractReadDriverCacheResultHandle(byte[] verbResponseData,
                                                  int responseSize)

  Extract the result data handle from the wire data returned as a result of `DSV_SET_REPLICATION_FILTER` with `DSVR_CACHE_UTIL`, version 0.

  Parameters:
    `verbResponseData` - data returned as a result of the DS verb request.
    `responseSize` - size of value data in `verbResponseData` array.
  Returns:
    handle to result data
  See Also:
    `DSVR_CACHE_UTIL`, `constructReadDriverCache(java.lang.String,int,int,int)`, `constructGetChunkedResult(int,int,int)`, `constructCloseChunkedResult(int)`

### extractReadDriverCacheResultSize

    public int extractReadDriverCacheResultSize(byte[] verbResponseData,
                                                int responseSize)

  Extract the result data size from the wire data returned as a result of `DSV_SET_REPLICATION_FILTER` with `DSVR_CACHE_UTIL`, version 0.

  Parameters:
    `verbResponseData` - data returned as a result of the DS verb request.
    `responseSize` - size of value data in `verbResponseData` array.
  Returns:
    total size of result data
  See Also:
    `DSVR_CACHE_UTIL`, `constructReadDriverCache(java.lang.String,int,int,int)`, `constructGetChunkedResult(int,int,int)`

### extractReadDriverCachePositionToken

    public int extractReadDriverCachePositionToken(byte[] verbResponseData,
                                                   int responseSize)

  Extract the offset token from the wire data returned as a result of `DSV_SET_REPLICATION_FILTER` with `DSVR_CACHE_UTIL`, version 0.

  Parameters:
    `verbResponseData` - data returned as a result of the DS verb request.
    `responseSize` - size of value data in `verbResponseData` array.
  Returns:
    position token
  See Also:
    `DSVR_CACHE_UTIL`, `constructReadDriverCache(java.lang.String,int,int,int)`

### constructDeleteDriverCache

    public DxWire.DxWireData constructDeleteDriverCache(String driverDN,
                                                        int positionToken,
                                                        int transactionCount,
                                                        String eventID)

  Construct a wire-format buffer to send a DSVR_CACHE_UTIL version 1 request to a DirXML driver.

  Parameters:
    `driverDN` - DN of driver from whose cache one or more transaction records are to be deleted.
    `positionToken` - 0 or value returned from earlier DSVR_CACHE_UTIL version 0 request.
    `transactionCount` - number of transaction records to delete
    `eventID` - event-id value of first transaction to delete (may be null or empty)
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_CACHE_UTIL`

### constructGetPasswordsState

    public DxWire.DxWireData constructGetPasswordsState(String driverDN)

  Construct a wire-format buffer to send a DSVR_GET_PASSWORDS_STATE version 0 request to a DirXML driver.

  Parameters:
    `driverDN` - DN of driver whose passwords state should be returned.
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_GET_PASSWORDS_STATE`

### extractGetPasswordsState

    public boolean[] extractGetPasswordsState(byte[] verbResponseData,
                                              int responseSize)

  Extract information on the passwords state returned from a DSVR_GET_PASSWORDS_STATE verb, version 0.

  If the raw 32-bit return value is desired use extractUint32().

  Parameters:
    `verbResponseData` - data returned as a result of the DS verb request.
    `responseSize` - size of value data in `verbResponseData` array.
  Returns:
    Array of 3 booleans that contain the passwords state: entries 0, 1, and 2 correspond to the Driver Object password, the application password, and the remote loader password, respectively.
  See Also:
    `DSVR_GET_PASSWORDS_STATE`, `constructGetPasswordsState(java.lang.String)`

### constructRegenerateKey

    public DxWire.DxWireData constructRegenerateKey(int type)

  Construct a wire-format buffer to send a DSVR_REGENERATE_KEY version 0 request to a DirXML driver.

  Parameters:
    `type` - flag indicating which public/private key pair to regenerate.
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_REGENERATE_KEY`

### constructGetServerCert

    public DxWire.DxWireData constructGetServerCert(int returnFormat)

  Construct a wire-format buffer to send a DSVR_GET_SERVER_CERT version 0 request to a DirXML server.

  Parameters:
    `returnFormat` - 0 for binary DER, 1 for base64 DER.
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_GET_SERVER_CERT`

### extractServerCert

    public byte[] extractServerCert(byte[] verbResponseData,
                                    int responseSize)

  Extract the X.509 certificate data returned in response to a DSVR_GET_SERVER_CERT request.

  Parameters:
    `verbResponseData` - data returned as a result of the DS verb request.
    `responseSize` - size of value data in `verbResponseData` array.
  Returns:
    Server certificate data.
  See Also:
    `DSVR_GET_SERVER_CERT`, `constructGetServerCert(int)`

### constructDiscoverJobs

    public DxWire.DxWireData constructDiscoverJobs(String dn,
                                                   int timeoutPeriod)

  Construct a wire-format buffer to send a DSVR_DISCOVER_JOBS version 0 request to a DirXML server.

  Parameters:
    `dn` - DN of DirXML-DriverSet or DirXML-Driver object.
    `timeoutPeriod` - timeout period, in minutes for result data. 0-10 are valid values, but value is not checked.
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_DISCOVER_JOBS`

### constructDiscoverAllJobs

    public DxWire.DxWireData constructDiscoverAllJobs(String dn,
                                                      int timeoutPeriod)

  Construct a wire-format buffer to send a DSVR_DISCOVER_JOBS version 1 request to a DirXML server.

  Parameters:
    `dn` - DN of DirXML-DriverSet or DirXML-Driver object.
    `timeoutPeriod` - timeout period, in minutes for result data. 0-10 are valid values, but value is not checked.
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_DISCOVER_JOBS`

### constructNotifyJobUpdate

    public DxWire.DxWireData constructNotifyJobUpdate(String jobObjectDN)

  Construct a wire-format buffer to send a DSVR_NOTIFY_JOB_UPDATE version 0 request to a DirXML server.

  Parameters:
    `jobObjectDN` - DN of the DirXML-Job object that has been modified
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_NOTIFY_JOB_UPDATE`

### constructStartJob

    public DxWire.DxWireData constructStartJob(String jobObjectDN)

  Construct a wire-format buffer to send a DSVR_START_JOB version 0 request to a DirXML server.

  Parameters:
    `jobObjectDN` - DN of the DirXML-Job object that has been modified
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_START_JOB`

### constructAbortJob

    public DxWire.DxWireData constructAbortJob(String jobObjectDN)

  Construct a wire-format buffer to send a DSVR_ABORT_JOB version 0 request to a DirXML server.

  Parameters:
    `jobObjectDN` - DN of the DirXML-Job object that has been modified
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_ABORT_JOB`

### constructGetJobState

    public DxWire.DxWireData constructGetJobState(String jobObjectDN)

  Construct a wire-format buffer to send a DSVR_GET_JOB_STATE version 0 request to a DirXML server.

  Parameters:
    `jobObjectDN` - DN of the DirXML-Job object that has been modified
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_GET_JOB_STATE`, `extractJobRunningState(byte[],int)`, `extractJobConfigState(byte[],int)`, `extractJobNextTime(byte[],int)`

### constructCheckJobConfig

    public DxWire.DxWireData constructCheckJobConfig(String jobObjectDN,
                                                     String language,
                                                     String country,
                                                     int timeoutPeriod)

  Construct a wire-format buffer to send a DSVR_CHECK_JOB_CONFIG version 0 request to a DirXML server.

  Parameters:
    `jobObjectDN` - DN of the DirXML-Job object
    `language` - two-char language identifier (e.g., "EN")
    `country` - two-char country identifier (e.g., "US")
    `timeoutPeriod` - timeout period, in minutes for result data. 0-10 are valid values, but value is not checked. 0 means use the default.
  Returns:
    `DxWireData` instance containing wire information.
  See Also:
    `DSVR_GET_JOB_STATE`, `extractJobRunningState(byte[],int)`, `extractJobConfigState(byte[],int)`, `extractJobNextTime(byte[],int)`

### extractJobRunningState

    public int extractJobRunningState(byte[] verbResponseData,
                                      int responseSize)

  Extract the 32-bit value from the results of a DSVR_GET_JOB_STATE request that contains the job's running state.

  Parameters:
    `verbResponseData` - data returned as a result of a DS verb request.
    `responseSize` - size of value data in `verbResponseData` array.
  Returns:
    32 bit value (0 means stopped, 1 means running)

### extractJobConfigState

    public int extractJobConfigState(byte[] verbResponseData,
                                     int responseSize)

  Extract the 32-bit value from the results of a DSVR_GET_JOB_STATE request that contains the job's configuration state.

  Parameters:
    `verbResponseData` - data returned as a result of a DS verb request.
    `responseSize` - size of value data in `verbResponseData` array.
  Returns:
    32 bit value (0 = enabled, 1 = disabled, 2 = configuration error)

### extractJobNextTime

    public long extractJobNextTime(byte[] verbResponseData,
                                   int responseSize)

  Extract the 32-bit value from the results of a DSVR_GET_JOB_STATE request that contains the job's next run time and return it as a `long` that can be used with `java.util.Date`.

  Parameters:
    `verbResponseData` - data returned as a result of a DS verb request.
    `responseSize` - size of value data in `verbResponseData` array.
  Returns:
    time value

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD